---
title: IDBObjectStore.add()
slug: Web/API/IDBObjectStore/add
tags:
  - API
  - Database
  - IDBObjectStore
  - IndexedDB
  - Method
  - Reference
  - Storage
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>add()</code></strong> method of the {{domxref("IDBObjectStore")}} interface returns an {{domxref("IDBRequest")}} object, and, in a separate thread, creates a <a href="http://www.whatwg.org/specs/web-apps/current-work/multipage/common-dom-interfaces.html#structured-clone">structured clone</a> of the value, and stores the cloned value in the object store. This is for adding new records to an object store.</p>
</div>

<p>To determine if the add operation has completed successfully, listen for the transaction’s <code>complete</code> event in addition to the <code>IDBObjectStore.add</code> request’s <code>success</code> event, because the transaction may still fail after the success event fires. In other words, the success event is only triggered when the transaction has been successfully queued.</p>

<p>The add method is an<span class="database"> <em>insert only</em> </span>method. If a record already exists in the object store with the <code>key</code> parameter as its key, then an error <code>ConstrainError</code> event is fired on the returned request object. For updating existing records, you should use the {{domxref("IDBObjectStore.put")}} method instead.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>request</em> = objectStore.add(<em>value</em>);
var <em>request</em> = objectStore.add(<em>value</em>, <em>key</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>value</dt>
 <dd>The value to be stored.</dd>
 <dt>key {{optional_inline}}</dt>
 <dd>The key to use to identify the record. If unspecified, it results to null.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p><span style="line-height: 1.5;">An </span><span style="line-height: 1.5;">{{domxref("IDBRequest")}}</span><span style="line-height: 1.5;"> object on</span><span style="line-height: 1.5;"> which subsequent events related to this operation are fired.</span></p>

<h3 id="Exceptions">Exceptions</h3>

<p><span style="line-height: 1.5;">This method may raise a {{domxref("DOMException")}} of one of the following types:</span></p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>ReadOnlyError</code></td>
   <td>The transaction associated with this operation is in read-only <a href="/en-US/docs/IndexedDB/IDBTransaction#mode_constants">mode</a>.</td>
  </tr>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>This {{domxref("IDBObjectStore")}}'s transaction is inactive.</td>
  </tr>
  <tr>
   <td><code><span style="line-height: normal;">DataError</span></code></td>
   <td>
    <p>Any of the following conditions apply:</p>

    <ul>
     <li>The object store uses in-line keys or has a key generator, and a key parameter was provided.</li>
     <li>The object store uses out-of-line keys and has no key generator, and no key parameter was provided.</li>
     <li>The object store uses in-line keys but no key generator, and the object store's key path does not yield a valid key.</li>
     <li>The key parameter was provided but does not contain a valid key.</li>
    </ul>
   </td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("IDBObjectStore")}} has been deleted or removed.</td>
  </tr>
  <tr>
   <td><code>DataCloneError</code></td>
   <td>The data being stored could not be cloned by the internal structured cloning algorithm.<br>
     </td>
  </tr>
  <tr>
   <td><code class="idl">ConstraintError</code></td>
   <td>An insert operation failed because the primary key constraint was violated (due to an already existing record with the same primary key value).</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>In the following code snippet, we open a read/write transaction on our database and add some data to an object store using <code>add()</code>. Note also the functions attached to transaction event handlers to report on the outcome of the transaction opening in the event of success or failure. For a full working example, see our <a href="https://github.com/mdn/to-do-notifications/" style="line-height: 1.5;">To-do Notifications</a><span style="line-height: 1.5;"> app (</span><a href="https://mdn.github.io/to-do-notifications/" style="line-height: 1.5;">view example live</a><span style="line-height: 1.5;">.)</span></p>

<pre class="brush: js">// Let us open our database
<span style="line-height: 1.5;">var DBOpenRequest = window.indexedDB.open("toDoList", 4);

</span><span style="line-height: 1.5;">DBOpenRequest.onsuccess = function(event) {</span>
  note.innerHTML += '&lt;li&gt;Database initialised.&lt;/li&gt;';

  // store the result of opening the database in the db variable.
  // This is used a lot below
  db = DBOpenRequest.result;

  // Run the addData() function to add the data to the database
  addData();
};

function addData() {
  // Create a new object ready to insert into the IDB
  var newItem = [ { taskTitle: "Walk dog", hours: 19, minutes: 30, day: 24, month: "December", year: 2013, notified: "no" } ];

  // open a read/write db transaction, ready for adding the data
  var transaction = db.transaction(["toDoList"], "readwrite");

  // report on the success of the transaction completing, when everything is done
  transaction.oncomplete = function(event) {
    note.innerHTML += '&lt;li&gt;Transaction completed.&lt;/li&gt;';
  };

  transaction.onerror = function(event) {
  note.innerHTML += '&lt;li&gt;Transaction not opened due to error. Duplicate items not allowed.&lt;/li&gt;';
  };

  // create an object store on the transaction
  var objectStore = transaction.objectStore("toDoList");

  // Make a request to add our newItem object to the object store
  var objectStoreRequest = objectStore.add(newItem[0]);

  objectStoreRequest.onsuccess = function(event) {
    // report the success of our request
    note.innerHTML += '&lt;li&gt;Request successful.&lt;/li&gt;';
  };
};</pre>

<h2 id="Specification"><span style="font-size: 2.14285714285714rem;">Specification</span></h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbobjectstore-add', 'add()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbobjectstore-add", "add()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBObjectStore.add")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
